import React__default,{useState,useEffect}from'react';import {Spin}from'antd';import TimerWidget from'./TimerWidget/index.js';import {useDispatch,useSelector}from'react-redux';import {currentTimerSelector,setCurrentTimerAction,resetCurrentTimerAction}from'@admin-layout/timetracker-core';import WeeklyRecord from'./WeeklyRecord/index.js';import'tslib';import {msToHMS,calcDurationTimeMilliSec}from'../../../utils/timeConverter.js';import {useGetTimeRecordsQuery}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import {useTimeformat}from'../../hooks/index.js';import moment from'moment';const getDate = (startDate, endDate) => {
    if (moment(startDate).format("ddd, Do MMM'YY") === moment(endDate).format("ddd, Do MMM'YY")) {
        return moment(startDate).format("ddd, Do MMM'YY");
    }
    return `${moment(startDate).format("ddd, Do MMM")} - ${moment(endDate).format("ddd, Do MMM'YY")}`;
};
const groupTimeRecords = (timeRecords, dateFormat) => {
    if (!timeRecords)
        return [];
    timeRecords.sort((a, b) => {
        if (moment(a.endTime) < moment(b.endTime))
            return 1;
        else if (moment(a.endTime) > moment(b.endTime))
            return -1;
        else
            return 0;
    });
    let groupedDates = {};
    for (let i = 0; i < timeRecords.length; i++) {
        const date = moment(timeRecords[i].endTime);
        const dateStr = moment(date).startOf('week').format(dateFormat);
        if (!groupedDates.hasOwnProperty(dateStr)) {
            groupedDates[dateStr] = [];
        }
        groupedDates[dateStr].push(timeRecords[i]);
    }
    let groupedDateArray = [];
    for (let key of Object.keys(groupedDates)) {
        let timeArray = groupedDates[key];
        const startDate = moment(key).startOf('week').format('ddd, MMM DD');
        const endDate = moment(key).endOf('week').format('ddd, MMM DD');
        let totalDurations = 0;
        let groupedDays = {};
        timeArray.forEach((data) => {
            totalDurations += calcDurationTimeMilliSec(data.startTime, data.endTime);
            const dateString = getDate(data.startTime, data.endTime);
            if (!groupedDays.hasOwnProperty(dateString)) {
                groupedDays[dateString] = [];
            }
            groupedDays[dateString].push(data);
        });
        let groupedDaysArray = [];
        for (let dayKey of Object.keys(groupedDays)) {
            let duration = 0;
            groupedDays[dayKey].forEach((day) => {
                duration += calcDurationTimeMilliSec(day.startTime, day.endTime);
            });
            groupedDaysArray.push({
                date: dayKey,
                duration,
                days: groupedDays[dayKey],
            });
        }
        groupedDateArray.push({
            dates: `${startDate} - ${endDate}`,
            duration: totalDurations,
            groupedDays: groupedDaysArray,
        });
    }
    return groupedDateArray;
};
const TrayTimerHandler = (props) => {
    const dispatch = useDispatch();
    const currentTimer = useSelector(currentTimerSelector);
    const userId = useSelector((state) => state.user.auth0UserId);
    const [timeDuration, setTimeDuration] = useState(0);
    const [timeRecords, setTimeRecords] = useState([]);
    const [loading, setLoading] = useState(true);
    const { data, loading: loadingData, subscribeToMore: subscribeDurationTimeRecord, } = useGetTimeRecordsQuery({ variables: { userId } });
    const { dateFormat } = useTimeformat();
    useEffect(() => {
        setTimeout(() => {
            setLoading(false);
        }, 10);
    }, []);
    useEffect(() => {
        if (data) {
            setTimeRecords(groupTimeRecords(data.getTimeRecords, dateFormat));
        }
    }, [data, dateFormat]);
    const onChangeTrack = () => {
        console.log('----START TIMER', currentTimer);
        if (currentTimer.startTime === null) {
            dispatch(setCurrentTimerAction({
                endTime: null,
                startTime: new Date,
                projectId: 'testProject',
                taskId: 'testTask',
                id: '#1'
            }));
        }
        else {
            console.log('--DISPATCH');
            dispatch(resetCurrentTimerAction());
        }
    };
    const calculateTimeDuration = () => {
        const now = new Date().getTime();
        const statedTime = new Date(currentTimer.startTime).getTime();
        setTimeDuration((currentTimer.startTime === null) ? 0 : now - statedTime);
    };
    setTimeout(() => {
        calculateTimeDuration();
    }, 1000);
    // const timeLog: timeLog = {
    //   id: '#1',
    //   weeklyLogs: [
    //     {
    //       dates: 'Apr 26 - May 02',
    //       duration: 10 * 3600 + 47 * 60 + 23,
    //       days: [
    //         {
    //           dates: "Mon 26 Apr'21",
    //           duration: 10 * 3600 + 47 * 60 + 23,
    //           title: 'Title',
    //           price: 1000,
    //           description: 'description apr 26'
    //         }
    //       ]
    //     },
    //     {
    //       dates: 'May 03 - May 09',
    //       duration: 6 * 3600 + 47 * 60 + 23,
    //       days: [
    //         {
    //           dates: `Mon 04 May'21`,
    //           duration: 4 * 3600 + 30 * 60 + 48,
    //           title: 'title May 04',
    //           price: 1000,
    //           description: 'description May 04'
    //         },
    //         {
    //           dates: `Wed 06 May'21`,
    //           duration: 1 * 3600 + 30 * 60 + 48,
    //           title: 'title May 06',
    //           price: 1000,
    //           description: 'descriotion May 04'
    //         }
    //       ]
    //     }
    //   ]
    // }
    let tRecords = [];
    if (!loading) {
        tRecords = timeRecords;
    }
    return (React__default.createElement("div", null,
        React__default.createElement(TimerWidget, { onTrack: onChangeTrack, trackStarted: currentTimer.startTime, timeDuration: msToHMS(timeDuration) }),
        React__default.createElement(Spin, { spinning: loading || loadingData },
            React__default.createElement("div", { className: "time-logs" }, tRecords.map((log, index) => React__default.createElement(WeeklyRecord, { key: index, log: log }))))));
};export default TrayTimerHandler;//# sourceMappingURL=index.js.map
